Lucene++ - a full-featured, c++ search engine
API Documentation

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes
Lucene::DefaultSkipListWriter Class Reference

Implements the skip list writer for the default posting list format that stores positions and payloads. More...

`#include <DefaultSkipListWriter.h>`

Inheritance diagram for Lucene::DefaultSkipListWriter:

## Public Member Functions

| DefaultSkipListWriter (int32_t skipInterval, int32_t numberOfSkipLevels, int32_t docCount, const IndexOutputPtr &freqOutput, const IndexOutputPtr &proxOutput)
virtual | ~DefaultSkipListWriter ()
virtual String | getClassName ()
boost::shared_ptr< DefaultSkipListWriter > | shared_from_this ()
void | setFreqOutput (const IndexOutputPtr &freqOutput)
void | setProxOutput (const IndexOutputPtr &proxOutput)
void | setSkipData (int32_t doc, bool storePayloads, int32_t payloadLength)
| Sets the values for the current skip data.
Public Member Functions inherited from Lucene::MultiLevelSkipListWriter
| MultiLevelSkipListWriter (int32_t skipInterval, int32_t maxSkipLevels, int32_t df)
virtual | ~MultiLevelSkipListWriter ()
boost::shared_ptr< MultiLevelSkipListWriter > | shared_from_this ()
void | bufferSkip (int32_t df)
| Writes the current skip data to the buffers. The current document frequency determines the max level is skip data is to be written to.
int64_t | writeSkip (const IndexOutputPtr &output)
| Writes the buffered skip lists to the given output.
Public Member Functions inherited from Lucene::LuceneObject
virtual | ~LuceneObject ()
virtual void | initialize ()
| Called directly after instantiation to create objects that depend on this object being fully constructed.
virtual LuceneObjectPtr | clone (const LuceneObjectPtr &other=LuceneObjectPtr())
| Return clone of this object.
virtual int32_t | hashCode ()
| Return hash code for this object.
virtual bool | equals (const LuceneObjectPtr &other)
| Return whether two objects are equal.
virtual int32_t | compareTo (const LuceneObjectPtr &other)
| Compare two objects.
virtual String | toString ()
| Returns a string representation of the object.
Public Member Functions inherited from Lucene::LuceneSync
virtual | ~LuceneSync ()
virtual SynchronizePtr | getSync ()
| Return this object synchronize lock.
virtual LuceneSignalPtr | getSignal ()
| Return this object signal.
virtual void | lock (int32_t timeout=0)
| Lock this object using an optional timeout.
virtual void | unlock ()
| Unlock this object.
virtual bool | holdsLock ()
| Returns true if this object is currently locked by current thread.
virtual void | wait (int32_t timeout=0)
| Wait for signal using an optional timeout.
virtual void | notifyAll ()
| Notify all threads waiting for signal.

## Static Public Member Functions

static String | _getClassName ()
Static Public Member Functions inherited from Lucene::MultiLevelSkipListWriter
static String | _getClassName ()

## Protected Member Functions

virtual void | resetSkip ()
virtual void | writeSkipData (int32_t level, const IndexOutputPtr &skipBuffer)
| Subclasses must implement the actual skip data encoding in this method.
Protected Member Functions inherited from Lucene::MultiLevelSkipListWriter
void | init ()
Protected Member Functions inherited from Lucene::LuceneObject
| LuceneObject ()

## Protected Attributes

Collection< int32_t > | lastSkipDoc
Collection< int32_t > | lastSkipPayloadLength
Collection< int64_t > | lastSkipFreqPointer
Collection< int64_t > | lastSkipProxPointer
IndexOutputPtr | freqOutput
IndexOutputPtr | proxOutput
int32_t | curDoc
bool | curStorePayloads
int32_t | curPayloadLength
int64_t | curFreqPointer
int64_t | curProxPointer
Protected Attributes inherited from Lucene::MultiLevelSkipListWriter
int32_t | numberOfSkipLevels
| number of levels in this skip list
int32_t | skipInterval
| the skip interval in the list with level = 0
Collection< RAMOutputStreamPtr > | skipBuffer
| for every skip level a different buffer is used
Protected Attributes inherited from Lucene::LuceneSync
SynchronizePtr | objectLock
LuceneSignalPtr | objectSignal

## Detailed Description

Implements the skip list writer for the default posting list format that stores positions and payloads.

## Constructor & Destructor Documentation

## ◆ DefaultSkipListWriter()

Lucene::DefaultSkipListWriter::DefaultSkipListWriter | ( | int32_t | skipInterval,
|  | int32_t | numberOfSkipLevels,
|  | int32_t | docCount,
|  | const IndexOutputPtr & | freqOutput,
|  | const IndexOutputPtr & | proxOutput )

References freqOutput, Lucene::MultiLevelSkipListWriter::numberOfSkipLevels, proxOutput, and Lucene::MultiLevelSkipListWriter::skipInterval.

Referenced by _getClassName().

## ◆ ~DefaultSkipListWriter()

virtual Lucene::DefaultSkipListWriter::~DefaultSkipListWriter | ( |  | ) |

virtual

## Member Function Documentation

## ◆ _getClassName()

String Lucene::DefaultSkipListWriter::_getClassName | ( |  | ) |

inline static

References DefaultSkipListWriter().

## ◆ getClassName()

virtual String Lucene::DefaultSkipListWriter::getClassName | ( |  | ) |

inline virtual

Reimplemented from Lucene::MultiLevelSkipListWriter.

## ◆ resetSkip()

virtual void Lucene::DefaultSkipListWriter::resetSkip | ( |  | ) |

protected virtual

Reimplemented from Lucene::MultiLevelSkipListWriter.

## ◆ setFreqOutput()

void Lucene::DefaultSkipListWriter::setFreqOutput | ( | const IndexOutputPtr & | freqOutput | ) |

References freqOutput.

## ◆ setProxOutput()

void Lucene::DefaultSkipListWriter::setProxOutput | ( | const IndexOutputPtr & | proxOutput | ) |

References proxOutput.

## ◆ setSkipData()

void Lucene::DefaultSkipListWriter::setSkipData | ( | int32_t | doc,
|  | bool | storePayloads,
|  | int32_t | payloadLength )

Sets the values for the current skip data.

## ◆ shared_from_this()

boost::shared_ptr< DefaultSkipListWriter > Lucene::DefaultSkipListWriter::shared_from_this | ( |  | ) |

inline

## ◆ writeSkipData()

virtual void Lucene::DefaultSkipListWriter::writeSkipData | ( | int32_t | level,
|  | const IndexOutputPtr & | skipBuffer )

protected virtual

Subclasses must implement the actual skip data encoding in this method.

Parameters

  level | the level skip data shall be writing for
  skipBuffer | the skip buffer to write to

Implements Lucene::MultiLevelSkipListWriter.

References Lucene::MultiLevelSkipListWriter::skipBuffer.

## Field Documentation

## ◆ curDoc

int32_t Lucene::DefaultSkipListWriter::curDoc

protected

## ◆ curFreqPointer

int64_t Lucene::DefaultSkipListWriter::curFreqPointer

protected

## ◆ curPayloadLength

int32_t Lucene::DefaultSkipListWriter::curPayloadLength

protected

## ◆ curProxPointer

int64_t Lucene::DefaultSkipListWriter::curProxPointer

protected

## ◆ curStorePayloads

bool Lucene::DefaultSkipListWriter::curStorePayloads

protected

## ◆ freqOutput

IndexOutputPtr Lucene::DefaultSkipListWriter::freqOutput

protected

Referenced by DefaultSkipListWriter(), and setFreqOutput().

## ◆ lastSkipDoc

Collection<int32_t> Lucene::DefaultSkipListWriter::lastSkipDoc

protected

## ◆ lastSkipFreqPointer

Collection<int64_t> Lucene::DefaultSkipListWriter::lastSkipFreqPointer

protected

## ◆ lastSkipPayloadLength

Collection<int32_t> Lucene::DefaultSkipListWriter::lastSkipPayloadLength

protected

## ◆ lastSkipProxPointer

Collection<int64_t> Lucene::DefaultSkipListWriter::lastSkipProxPointer

protected

## ◆ proxOutput

IndexOutputPtr Lucene::DefaultSkipListWriter::proxOutput

protected

Referenced by DefaultSkipListWriter(), and setProxOutput().

The documentation for this class was generated from the following file:

- DefaultSkipListWriter.h

clucene.sourceforge.net